## org.eehouse.android.xw4_33_src.tar.gz

=== xwords4/Makefile ===

tags:
	etags $$(find . -name '*.c' -print \
		-o -name '*.h' -print \
		-o -name '*.cpp' -print \
		-o -name '*.java' -print \
)
