=== xwords4/common/Makefile ===
# -*- mode: Makefile; -*-

clean:
	rm -rf $(PLATFORM)
