=== xwords4/debian/changelog ===
xwords (4.4.0.0-1) unstable; urgency=low

  * Initial release (Closes: #nnnn)  <nnnn is the bug number of your ITP>

 -- Eric House <eehouse@eehouse.org>  Tue, 13 Dec 2011 18:47:41 -0800
