=== xwords4/debian/control ===
Source: xwords
Section: unknown
Priority: extra
Maintainer: Eric House <eehouse@eehouse.org>
Build-Depends: debhelper (>= 7.0.50~)
Standards-Version: 3.8.4
Homepage: <insert the upstream URL, if relevant>
#Vcs-Git: git://git.debian.org/collab-maint/xwords.git
#Vcs-Browser: http://git.debian.org/?p=collab-maint/xwords.git;a=summary

Package: xwords
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: <insert up to 60 chars description>
 <insert long description, indented with spaces>
